import { describe, test } from 'mocha'
import chai, { expect } from 'chai'

import chaiStats from 'chai-stats'

chai.use(chaiStats) // For almost assertion

import { combineFisher, holmCorrectP, median } from './stats'

const pValues = [1.00000000e+00, 9.97815867e-01, 3.83382306e-22, 1.00000000e+00,
    3.59251327e-60, 3.77355791e-04, 9.99999898e-01, 8.61064668e-01,
    1.99279010e-01, 4.25012608e-02, 9.29198949e-06, 9.99974595e-01,
    9.90229961e-01, 9.99999823e-01, 6.04552579e-01, 5.05780242e-06,
    8.81908071e-02, 3.32234749e-02, 9.25367744e-01, 1.43532561e-01,
    3.64899578e-01, 2.87234578e-17, 3.65318318e-03, 1.00000000e+00,
    3.59251327e-60, 1.00000000e+00, 9.99780618e-01, 2.39141786e-07,
    2.42401765e-01, 9.18647018e-01, 9.88903979e-01, 9.99995511e-01,
    5.83968591e-05, 1.78984699e-02, 4.34310150e-07, 4.91804562e-01,
    9.99997529e-01, 2.89467855e-01, 2.87234578e-17, 2.39971219e-03,
    9.98563358e-01, 9.65500496e-01, 1.74315600e-04, 8.48193567e-01,
    7.85792076e-01, 6.36356754e-01, 3.26944651e-01, 3.74580940e-01,
    3.60126497e-17, 9.99999994e-01, 9.99999491e-01, 3.65318318e-03,
    3.32032268e-02, 9.77582278e-01, 8.59039621e-01, 1.46014481e-02,
    2.03225216e-01, 8.95917026e-01, 4.35485022e-02, 6.07820236e-01,
    9.99980785e-01, 9.99998091e-01, 1.08194409e-09, 2.75900323e-01,
    1.00000000e+00, 9.99984194e-01, 2.90437830e-05, 1.27643929e-02,
    9.99999894e-01, 6.41890785e-01, 8.47016890e-02, 1.90445186e-05,
    1.38774776e-01, 9.81554593e-01, 6.46568705e-01, 9.99998665e-01,
    1.26439698e-14, 6.84318957e-01, 5.03534413e-02, 1.51366641e-02,
    5.95296768e-01, 3.92404960e-01, 5.03534413e-02, 3.59251327e-60,
    2.39971219e-03, 3.32032268e-02, 9.99984194e-01, 9.99999999e-01,
    1.02741933e-07, 1.45293371e-01, 6.15414911e-03, 6.54847141e-01,
    1.00000000e+00, 1.36195389e-04, 5.98196742e-07, 8.01913179e-03,
    1.83022466e-02, 9.99876300e-01, 4.73401722e-01, 5.48723770e-02,
    4.41356444e-01, 5.48723770e-02, 1.00000000e+00, 9.98563358e-01,
    9.77582278e-01, 2.90437830e-05, 1.47782601e-09, 9.99999957e-01,
    9.25768232e-01, 9.98728979e-01, 5.40474643e-01, 3.34234414e-13,
    9.99938611e-01, 9.99999824e-01, 9.95114273e-01, 9.90153757e-01,
    2.23812907e-04, 4.23344720e-01, 7.96988889e-01, 8.71713298e-01,
    9.99780618e-01, 9.65500496e-01, 8.59039621e-01, 1.27643929e-02,
    9.99999999e-01, 1.47782601e-09, 3.07544387e-34, 1.00000000e+00,
    1.00000000e+00, 8.65574734e-01, 5.93722820e-02, 5.93376333e-01,
    9.62468053e-01, 2.39141786e-07, 1.74315600e-04, 1.46014481e-02,
    9.99999894e-01, 1.02741933e-07, 9.99999957e-01, 1.00000000e+00,
    1.46595148e-10, 5.21199765e-01, 5.04941109e-03, 9.87249091e-01,
    8.88492941e-01, 8.73355295e-02, 4.21752474e-02, 8.73355295e-02,
    2.42401765e-01, 8.48193567e-01, 2.03225216e-01, 6.41890785e-01,
    1.45293371e-01, 9.25768232e-01, 9.93258587e-01, 6.49150797e-02,
    2.38155948e-01, 4.40319967e-01, 4.43300573e-01, 7.81918606e-01,
    9.18647018e-01, 7.85792076e-01, 8.47016890e-02, 6.15414911e-03,
    9.98728979e-01, 9.99999996e-01, 2.46124680e-03, 2.14366832e-04,
    5.45921543e-03, 9.88903979e-01, 1.90445186e-05, 6.54847141e-01,
    5.40474643e-01, 1.60844812e-04, 6.11465562e-06, 6.24968463e-02,
    4.18095071e-01, 9.99995511e-01, 6.36356754e-01, 8.95917026e-01,
    1.38774776e-01, 1.00000000e+00, 3.34234414e-13, 3.07544387e-34,
    1.00000000e+00, 9.93258587e-01, 9.99999996e-01, 8.53697300e-01,
    1.47881760e-03, 8.62564316e-01, 5.83968591e-05, 3.26944651e-01,
    4.35485022e-02, 9.81554593e-01, 1.36195389e-04, 9.99938611e-01,
    1.00000000e+00, 1.46595148e-10, 6.49150797e-02, 2.46124680e-03,
    1.60844812e-04, 3.74731728e-02, 9.59325619e-01, 8.11479227e-01,
    1.78984699e-02, 3.74580940e-01, 6.07820236e-01, 6.46568705e-01,
    5.98196742e-07, 9.99999824e-01, 1.00000000e+00, 5.21199765e-01,
    2.38155948e-01, 2.14366832e-04, 6.11465562e-06, 6.78705659e-01,
    3.95578350e-02, 5.19529175e-06, 3.67727350e-08, 5.42858507e-07,
    6.49081074e-17, 9.99979432e-01, 9.99998397e-01, 9.07850802e-03,
    9.94426347e-01, 8.70307613e-01, 4.79028553e-03, 4.37979023e-01,
    8.57848370e-01, 3.64230033e-02, 6.75080653e-01, 5.02275732e-01,
    9.99999995e-01, 9.99998006e-01, 1.08169271e-14, 1.96440483e-02,
    9.89362571e-01, 6.10312346e-02, 9.86884529e-01, 4.41786239e-01,
    6.20703065e-02, 1.53204269e-03, 9.58658544e-01, 9.99998617e-01,
    9.99999777e-01, 8.04285259e-10, 6.39852549e-01, 9.99926512e-01,
    1.35234536e-04, 6.21659051e-01, 8.76334763e-01, 7.75917184e-01,
    5.26480157e-03, 4.11986269e-01, 8.75192157e-01, 7.99566887e-01,
    3.68514181e-02, 1.96410099e-01, 1.02119425e-01, 5.75420212e-01,
    2.72212122e-01, 5.75420212e-01]

const expected = [1.00000000e+00, 1.00000000e+00, 9.85292527e-20, 1.00000000e+00,
    9.41238476e-58, 7.99994277e-02, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 2.12786559e-03, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.17846796e-03,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 7.35320519e-15, 7.48902552e-01, 1.00000000e+00,
    9.41238476e-58, 1.00000000e+00, 1.00000000e+00, 5.71548870e-05,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.30808964e-02, 1.00000000e+00, 1.02931506e-04, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 7.35320519e-15, 5.01539848e-01,
    1.00000000e+00, 1.00000000e+00, 3.78264852e-02, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    9.14721301e-15, 1.00000000e+00, 1.00000000e+00, 7.48902552e-01,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 2.65076301e-07, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 6.56389497e-03, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 4.34215024e-03,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    3.17363643e-12, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 9.41238476e-58,
    5.01539848e-01, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    2.47608059e-05, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 3.00991809e-02, 1.40576234e-04, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 6.56389497e-03, 3.60589547e-07, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 8.35586034e-11,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    4.76721491e-02, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 3.60589547e-07, 7.96539961e-32, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 5.71548870e-05, 3.78264852e-02, 1.00000000e+00,
    1.00000000e+00, 2.47608059e-05, 1.00000000e+00, 1.00000000e+00,
    3.63555967e-08, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 5.09478087e-01, 4.60888689e-02,
    1.00000000e+00, 1.00000000e+00, 4.34215024e-03, 1.00000000e+00,
    1.00000000e+00, 3.52250139e-02, 1.41248545e-03, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 8.35586034e-11, 7.96539961e-32,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    3.12030514e-01, 1.00000000e+00, 1.30808964e-02, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 3.00991809e-02, 1.00000000e+00,
    1.00000000e+00, 3.63555967e-08, 1.00000000e+00, 5.09478087e-01,
    3.52250139e-02, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.40576234e-04, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 4.60888689e-02, 1.41248545e-03, 1.00000000e+00,
    1.00000000e+00, 1.20530769e-03, 8.89900186e-06, 1.28114608e-04,
    1.64217512e-14, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 9.72427964e-01, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 2.72586563e-12, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 3.21728965e-01, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 1.97854174e-07, 1.00000000e+00, 1.00000000e+00,
    3.00220669e-02, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00, 1.00000000e+00, 1.00000000e+00,
    1.00000000e+00, 1.00000000e+00]

const decimalPrecision = 8

describe('stats', () => {
    describe('holm', () => {
        test('should return expected values', () => {
            const actual = holmCorrectP(pValues)
            expect(actual).to.almost.eql(expected, decimalPrecision)
        })
    })

    describe('Fisher\'s method', () => {
        test('one value', () => {
            expect(combineFisher([1.42924814e-06]))
                .to.almost.eql(1.42924814e-06, 8)
        })

        test('examples 1', () => {
            // Example taken from https://en.wikipedia.org/wiki/Fisher%27s_exact_test#Example
            expect(combineFisher([.01, .2, .3]))
                .to.almost.eql(0.02156, 4)

        })

        test('examples 2', () => {
            expect(combineFisher([3.85181569e-14, 4.86785548e-57, 3.13036598e-04, 5.67643366e-04, 6.25191832e-19]))
                .to.almost.eql(1.9971029783409714e-87, 8)

        })

        test('examples 3', () => {
            expect(combineFisher([5.16032584e-19, 4.86785548e-57, 1.20238344e-02, 6.57008534e-03,
                6.25191832e-19]))
                .to.almost.eql(1.3047364451888767e-89, 6)

        })

        test('empty', () => {
            expect(combineFisher([]))
                .to.eql(NaN)
        })
    })

    describe('median', () => {
        test('empty', () => {
            expect(median(new Map())).to.eql(undefined)
        })

        test('one', () => {
            expect(median(new Map([[3, 1]]))).to.eql(3)
        })

        test('two', () => {
            expect(median(new Map([[3, 2]]))).to.eql(3)
        })
        test('two average', () => {
            debugger
            expect(median(new Map([[3, 1], [5, 1]]))).to.eql(4)
        })
        test('three', () => {
            expect(median(new Map([[7, 1], [5, 1], [3, 1]]))).to.eql(5)
        })
        test('four', () => {
            expect(median(new Map([[7, 1], [5, 1], [3, 1], [9, 1]]))).to.eql(6)
        })
        test('four2', () => {
            expect(median(new Map([[3, 2], [5, 1], [7, 1], [9, 2]]))).to.eql(6)
        })
        test('four3', () => {
            expect(median(new Map([[3, 1], [7, 2], [5, 2], [9, 1]]))).to.eql(6)
        })
        test('four four', () => {
            debugger
            expect(median(new Map([[7, 1], [3, 1], [9, 2], [5, 2]]))).to.eql(6)
        })

        test('example 1', () => {
            expect(median(new Map([[61551, 1], [61581, 3]]))).to.eql(61581)
        })
    })

})


